Option Explicit

Sub Main
ControlarAplicacion5
End Sub

Sub ControlarAplicacion1()
Dim oDoc As Object
Dim oControlador As Object

	'El documento desde donde se llama esta macro
	oDoc = ThisComponent
	'El controllador del documento actual
	oControlador = oDoc.getCurrentController
	'El titulo
	MsgBox oControlador.getTitle
	
End Sub


Sub ControlarAplicacion2()
Dim oDocumentos As Object
Dim oDocumento As Object
Dim oVentana As Object
Dim oEnumeraDocumentos As Object

    'Accedemos a todos los documentos actualmente abiertos
    oDocumentos = StarDesktop.getComponents()
    'Enumeramos cada uno
    oEnumeraDocumentos = oDocumentos.createEnumeration()
    'hasMoreElements devuelve verdadero (True) mientras haya elementos
	Do While oEnumeraDocumentos.hasMoreElements()
        'Nos desplazamos al siguiente elemento y lo asignamos
        oDocumento = oEnumeraDocumentos.nextElement()
        'Obtenemos acceso a la ventana
        oVentana = oDocumento.getCurrentController.getFrame.getComponentWindow()
        'Le enviamos el foco para activarla
        oVentana.setFocus()
        'Esperamos 1.5 segundos para pasar al siguiente documento
    	Wait 1500
	Loop
	
End Sub


Sub ControlarAplicacion3()
Dim oBarraEstado As Object
Dim co1 As Integer

	'Referencia a la barra de estado del documento activo
	oBarraEstado = ThisComponent.getCurrentController.StatusIndicator
	'Establecemos el texto inicial y el limite de la barra de progreso
	oBarraEstado.start( "Contando ", 10 )
	For co1 = 1 To 10
		'Establecemos el valor de la barra de progreso
		oBarraEstado.setValue( co1 )
		'Esperamos un segundo
		Wait 1000
	Next
	'Es importante finalizar la barra de estado para devolverle el control a la aplicación
	oBarraEstado.end()

End Sub


Sub ControlarAplicacion4()
Dim oBarraEstado As Object
Dim co1 As Integer

	'Referencia a la barra de estado del documento activo
	oBarraEstado = ThisComponent.getCurrentController.StatusIndicator
	'Establecemos el texto inicial y el limite de la barra de progreso
	oBarraEstado.start( "Procesando Líneas ", 10 )
	For co1 = 1 To 10
		'Establecemos el valor de la barra de progreso
		oBarraEstado.setValue( co1 )
		'Y el texto
		oBarraEstado.setText( "Procesando la línea: " & co1 )
		'Esperamos un segundo
		Wait 1000
	Next
	'Es importante finalizar la barra de estado para devolverle el control a la aplicación
	oBarraEstado.end()

End Sub


Sub ControlarAplicacion5()
Dim oDoc As Object
Dim oDH As Object
dim mOpc(0) As New com.sun.star.beans.PropertyValue

	'Acceso al marco del documento
	oDoc = ThisComponent.CurrentController.Frame
	'El despachador de instrucciones a nivel usuario
	oDH = createUnoService("com.sun.star.frame.DispatchHelper")
	
	'El método que deseamos ejecutar
	mOpc(0).Name = "ZoomSlider.CurrentZoom"
	'El valor deseado, en este caso 150%
	mOpc(0).Value = 150
	'Ejecutamos la orden
	oDH.executeDispatch(oDoc, ".uno:ZoomSlider", "", 0, mOpc() )
	
End Sub



Sub ControlarAplicacion()
Dim oDatosT As Object
Dim oPortaP As Object
Dim oConvertir As Object
Dim mDatosPP
Dim vTexto
Dim vDatos
Dim sDatos
Dim co1

	oPortaP = createUnoService( "com.sun.star.datatransfer.clipboard.SystemClipboard")
	oConvertir = createUnoService( "com.sun.star.script.Converter" )
	oDatosT = oPortaP.getContents()
	mDatosPP = oDatosT.getTransferDataFlavors()
 	vTexto = Null
 	Dim stmp
	For co1 = 0 To UBound( mDatosPP )
 			If mDatosPP(co1).HumanPresentableName = "Text" Then
				vTexto = mDatosPP(co1)
			End If
	Next co1
 
	If Not IsNull( vTexto ) Then
		vDatos = oDatosT.getTransferData( vTexto )
 		sDatos = oConvertir.convertToSimpleType( vDatos, com.sun.star.uno.TypeClass.STRING)
 		MsgBox sDatos
 		
	End If
 
End Sub



